Attribute VB_Name = "Modulo_Declaraciones"
'//////////////////////////////////////////////////////////////
'   Declaraciones de estructuras
'//////////////////////////////////////////////////////////////
Public Type respuesta
    Arriba As Long
    Abajo As Long
    Derecha As Long
    Izquierda As Long
    Switch As Long
End Type

Public Type MILParams
    Aplicacion As Long
    SistemaVGA As Long
    SistemaMETEOR As Long
    MILUnderlayBuffer As Long
    Display As Long
End Type

Public Type PeriodosConfiguracion
    Camara As Long
    PanTilt As Long
    robot As Long
End Type

'///////////////////////////////////////////////////////////////
'   Declaracion de variables globales
'///////////////////////////////////////////////////////////////

'               Variables de las ventanas MIL
Public PantallaPrincipal As MILParams
Public DisplayCamara, BufferCamara, Digitalizador As Long

'               Variables referentes al control del Robot
Public Arriba As Long
Public Izquierda As Long
Public Derecha As Long
Public Abajo As Long
Public ArribaRobot As Long
Public IzquierdaRobot As Long
Public DerechaRobot As Long
Public AbajoRobot As Long
Public Pos_PAN As Double
Public Pos_TILT As Double
Public velocidad_PT As Long
Public velocidad_Robot_Tras As Long
Public velocidad_Robot_Giro As Long


'                 Variables de estado de este programa (Navigator)
Public final As Boolean
Public NavigatorPath As String
Public DirectInputSystem As Boolean
Public TipoConexion As Integer
Public TipoRepresentacion As Integer
Public TipoControl As Long
Public DireccionIP As String
Public PanTiltIP As String
Public CamarasConectadas As Boolean
Public RobotConectado As Boolean
Public PeriodoControles As PeriodosConfiguracion
Public ConectarCamaras As Boolean
Public MapaCargado As Boolean
Public escala As Double
Public Estado_Mouse As String
Public Mouse_X_Pos As Single
Public Mouse_Y_Pos As Single
Public DesplazamientoX_Acumulado As Double
Public DesplazamientoY_Acumulado As Double
Public DesplazamientoX As Double
Public DesplazamientoY As Double
Public AnguloMapa As Double

'               Variables de estado del Robot Virtual
Public Xpos As Double
Public Ypos As Double
Public Xpos_inic As Double
Public Ypos_inic As Double
Public AnguloActual As Double
Public AnguloCamaras As Double

'//////////////////////////////////////////////////////////////
'   Declaracion de Funciones externas
'//////////////////////////////////////////////////////////////

Declare Sub InicializarSystemaMIL Lib "DllControl.dll" Alias "_InicializarSystemaMIL@8" _
    (ByRef Aplicacion As Long, ByRef SistemaVGA As Long)
    
Declare Sub CerrarSystemaMIL Lib "DllControl.dll" Alias "_CerrarSystemaMIL@12" _
    (ByVal Aplicacion As Long, ByVal SistemaVGA As Long, ByVal SistemaMETEOR As Long)

Declare Function IniciarDInput Lib "DllControl.dll" Alias "_IniciarDInput@4" _
    (ByVal dispositivo As Long) As Integer
    
Declare Sub CerrarDInput Lib "DllControl.dll" Alias "_CerrarDInput@0" ()

Declare Function DirectInputPollDevice Lib "DllControl.dll" Alias "_DirectInputPollDevice@0" () _
    As respuesta

Declare Function NonDirectInputPollDevice Lib "DllControl.dll" Alias "_NonDirectInputPollDevice@0" () _
    As respuesta

Declare Sub ConectarCamaraMIL Lib "DllControl.dll" Alias "_ConectarCamaraMIL@28" _
    (ByVal VentanaHandle As Long, ByRef Sistema As Long, ByRef DisplayCamara As Long _
    , ByRef BufferCamara As Long, ByRef Digitalizador As Long, ByVal alto As Long _
    , ByVal ancho As Long)

Declare Sub DesconectarCamaraMIL Lib "DllControl.dll" Alias "_DesconectarCamaraMIL@12" _
    (ByVal DisplayCamara As Long, ByVal Digitalizer As Long, ByVal BufferCamara As Long)
    
Declare Sub CaptarImagenCamaraMIL Lib "DllControl.dll" Alias "_CaptarImagenCamaraMIL@8" _
    (ByVal Digitalizer As Long, ByVal Buffer As Long)
    
Declare Sub AbrirMapaMIL Lib "DllControl.dll" Alias "_AbrirMapaMIL@52" _
    (ByVal VentanaHandle As Long, ByVal NombreFichero As String, ByVal DirectorioObjetos As String _
     , ByRef alto As Long, ByRef ancho As Long, ByVal escala As Double, ByRef PosX As Double, _
     ByRef PosY As Double, ByRef heading As Double, ByVal Sistema As Long, ByRef Display As Long, _
     ByRef UnderlayBuffer As Long)

Declare Sub NuevoMapaMIL Lib "DllControl.dll" Alias "_NuevoMapaMIL@32" _
    (ByVal VentanaHandle As Long, ByVal alto As Long, ByVal ancho As Long, _
    ByVal escala As Double, ByVal Sistema As Long, ByRef Display As Long, _
    ByRef UnderlayBuffer As Long)
    
Declare Sub SalvarMapaMIL Lib "DllControl.dll" Alias "_SalvarMapaMIL@4" _
    (ByVal FileName As String)
    
Declare Sub RecalcularMapaMIL Lib "DllControl.dll" Alias "_RecalcularMapaMIL@44" _
    (ByVal escala As Double, ByVal DesplazamientoH As Double, ByVal DesplazamientoV As Double _
    , ByVal AnguloGiro As Double, ByVal EjeGiroX As Long, ByVal EjeGiroY As Long, ByVal modo As Long)
    
Declare Sub CerrarMapaMIL Lib "DllControl.dll" Alias "_CerrarMapaMIL@4" _
    (ByVal Display As Long)
    
Declare Sub AjustarZonaAltaResolucion Lib "DllControl.dll" Alias "_AjustarZonaAltaResolucion@16" _
    (ByVal XSupIzq As Long, ByVal YSupIzq As Long, ByVal XInfDrch As Long, ByVal YInfDrch As Long)
    
Declare Sub UsarZonaAltaResolucion Lib "DllControl.dll" Alias "_UsarZonaAltaResolucion@0" ()

Declare Sub NoUsarZonaAltaResolucion Lib "DllControl.dll" Alias "_NoUsarZonaAltaResolucion@0" ()
            
Declare Function ConectarPAN_TILT Lib "DllControl.dll" Alias "_ConectarPAN_TILT@4" _
    (ByVal PanTiltIP As String) As Long
    
Declare Sub DesconectarPAN_TILT Lib "DllControl.dll" Alias "_DesconectarPAN_TILT@0" ()

Declare Sub PanDerecha Lib "DllControl.dll" Alias "_PanDerecha@4" _
    (ByVal dato As Long)
    
Declare Sub PanIzquierda Lib "DllControl.dll" Alias "_PanIzquierda@4" _
    (ByVal dato As Long)
    
Declare Sub TiltArriba Lib "DllControl.dll" Alias "_TiltArriba@4" _
    (ByVal dato As Long)
    
Declare Sub TiltAbajo Lib "DllControl.dll" Alias "_TiltAbajo@4" _
    (ByVal dato As Long)

Declare Sub DetenerPan Lib "DllControl.dll" Alias "_DetenerPan@0" ()

Declare Sub DetenerTilt Lib "DllControl.dll" Alias "_DetenerTilt@0" ()

Declare Function PosicionPAN Lib "DllControl.dll" Alias "_PosicionPAN@0" () _
    As Long

Declare Function PosicionTILT Lib "DllControl.dll" Alias "_PosicionTILT@0" () _
    As Long
    
Declare Function VelocidadPAN Lib "DllControl.dll" Alias "_VelocidadPAN@0" () _
    As Long
        
Declare Sub GirarPanHastaAnguloN Lib "DllControl.dll" Alias "_GirarPanHastaAnguloN@8" _
    (ByVal AnguloDestino As Long, ByVal VelocidadGiro As Long)

Declare Sub GirarTiltHastaAnguloN Lib "DllControl.dll" Alias "_GirarTiltHastaAnguloN@8" _
    (ByVal AnguloDestino As Long, ByVal VelocidadGiro As Long)

Declare Function ConexionConRobot Lib "DllControl.dll" Alias "_ConexionConRobot@32" _
    (ByVal TipoConexion As Long, ByVal XPosInic As Double, _
    ByVal YposInic As Double, ByVal heading As Double, ByVal DireccionIP As String) As Long

Declare Sub DesconexionRobot Lib "DllControl.dll" Alias "_DesconexionRobot@0" ()

Declare Sub GirarRobotDerecha Lib "DllControl.dll" Alias "_GirarRobotDerecha@4" _
    (ByVal velocidad As Long)
    
Declare Sub GirarRobotIzquierda Lib "DllControl.dll" Alias "_GirarRobotIzquierda@4" _
    (ByVal velocidad As Long)
    
Declare Sub GirarRobotHastaAnguloN Lib "DllControl.dll" Alias "_GirarRobotHastaAnguloN@8" _
    (ByVal Angulo As Double)
    
Declare Sub DetenerGiroRobot Lib "DllControl.dll" Alias "_DetenerGiroRobot@0" ()

Declare Sub AvanzarRobot Lib "DllControl.dll" Alias "_AvanzarRobot@4" _
    (ByVal velocidad As Long)
    
Declare Sub RetrocederRobot Lib "DllControl.dll" Alias "_RetrocederRobot@4" _
    (ByVal velocidad As Long)

Declare Sub DetenerTraslacionRobot Lib "DllControl.dll" Alias "_DetenerTraslacionRobot@0" ()

Declare Sub GetRobotPosition Lib "DllControl.dll" Alias "_GetRobotPosition@12" _
    (ByRef Xpos As Double, ByRef Ypos As Double, ByRef heading As Double)
        
Declare Sub CargarBehaviors Lib "DllControl.dll" Alias "_CargarBehaviors@4" ( _
    ByRef Parametros As BehaviorsParams)
    
Declare Sub DescargarBehaviors Lib "DllControl.dll" Alias "_DescargarBehaviors@0" ()
    
Declare Sub Behav_ConstVelocity Lib "DllControl.dll" Alias "_Behav_ConstVelocity@16" _
    (ByVal NombreInstancia As String, ByVal TimeOut As Long, ByVal Prioridad As Long, _
    ByVal Suspension As Long)
    
Declare Sub Behav_AvoidCollision Lib "DllControl.dll" Alias "_Behav_AvoidCollision@16" _
    (ByVal NombreInstancia As String, ByVal TimeOut As Long, ByVal Prioridad As Long, _
    ByVal Suspension As Long)
    
Declare Sub Behav_KeepOff Lib "DllControl.dll" Alias "_Behav_AvoidCollision@16" _
    (ByVal NombreInstancia As String, ByVal TimeOut As Long, ByVal Prioridad As Long, _
    ByVal Suspension As Long)
    
Declare Sub Behav_Loaded Lib "DllControl.dll" Alias "_Behav_Loaded@8" _
    (ByVal NombreFichero As String, ByVal NombreInstancia As String)
    
Declare Sub Behav_Resume Lib "DllControl.dll" Alias "_Behav_Resume@4" _
    (ByVal NombreInstancia As String)
    
Declare Sub Behav_Kill Lib "DllControl.dll" Alias "_Behav_Kill@4" _
    (ByVal NombreInstancia As String)
    
Declare Sub Behav_Pause Lib "DllControl.dll" Alias "_Behav_Pause@4" _
    (ByVal NombreInstancia As String)
    
Declare Sub PosicionarRobotVirtual Lib "DllControl.dll" Alias "_PosicionarRobotVirtual@36" _
    (ByVal X As Double, ByVal Y As Double, ByVal AnguloActual As Double, ByVal AnguloCamaras As Double _
    , ByVal modo As Long)
    
Declare Sub ActualizarVista Lib "DllControl.dll" Alias "_ActualizarVista@36" _
    (ByVal X As Double, ByVal Y As Double, ByVal AnguloActual As Double, _
    ByVal AnguloCamaras As Double, ByVal modo As Long)

Declare Sub TransfMundoDispositivo Lib "DllControl.dll" Alias "_TransfMundoDispositivo@24" _
    (ByVal PosXMundo As Double, ByVal PosYMundo As Double, _
    ByRef PosXDisp As Double, ByRef PosYDisp As Double)

Declare Sub TransfDispositivoMundo Lib "DllControl.dll" Alias "_TransfDispositivoMundo@24" _
    (ByVal PosXDisp As Double, ByVal PosYDisp As Double, _
    ByRef PosXMundo As Double, ByRef PosYMundo As Double)

Declare Sub ObtenerLecturaSonares Lib "DllControl.dll" Alias "_ObtenerLecturaSonares@0" ()
        
Declare Sub VaciarBufferLecturasSonares Lib "DllControl.dll" Alias "_VaciarBufferLecturasSonares@0" ()

Declare Sub SeguirSpline Lib "DllControl.dll" Alias "_SeguirSpline@28" _
    (ByVal X As Long, ByVal Y As Long, ByVal th As Long, ByVal vel As Double, ByVal Radio As Double)
    
Declare Sub SplineTracer Lib "DllControl.dll" Alias "_SplineTracer@32" _
    (ByVal x1 As Double, ByVal y1 As Double, ByVal x2 As Double, ByVal y2 As Double)

Declare Sub PintarPuntoTrayectoria Lib "DllControl.dll" Alias "_PintarPuntoTrayectoria@16" _
    (ByVal x1 As Double, ByVal y1 As Double)
    
Declare Function ThreadState Lib "DllControl.dll" Alias "_ThreadState@0" () As Integer

Declare Sub Prueba Lib "DllControl.dll" Alias "_Prueba@0" ()

Declare Sub GrabarBuffer Lib "DllControl.dll" Alias "_GrabarBuffer@0" ()

Declare Sub splinetemp Lib "DllControl.dll" Alias "_splinetemp@0" ()

Declare Sub LanzarThreadPanTilt Lib "DllControl.dll" Alias "_LanzarThreadPanTilt@8" _
 (ByVal Operacion As Long, ByVal velocidad As Long)

'//////////////////////////////////////////////////////////////
'   Funcion de Inicio
'///////////////////////////////////////////////////////////////
Sub Main()
    Dim respuesta As Integer
    
    TipoControl = 0
    SplashScreen.Show
    SplashScreen.Mensajes.Text = "Detectando presencia de DirectInput ..."
    DoEvents
    respuesta = IniciarDInput(TipoControl)
    If respuesta = 1 Then
        SplashScreen.Mensajes.Text = "DirectInput detectado"
        DirectInputSystem = True
    ElseIf respuesta = 0 Then
        SplashScreen.Mensajes.Text = "DirectInput NO detectado"
        DirectInputSystem = False
    End If
    SplashScreen.Timer1.Enabled = True
End Sub
